'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StaRHsStatusType = exports.StaRHsStatusContext = exports.StaRHsStatus = undefined;

var _tcomb = require('tcomb');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ZeroOrPositiveIntegerType = (0, _tcomb.refinement)(_tcomb.Number, function (n) {
  return n >= 0 && n % 1 === 0;
}, 'ZeroOrPositiveIntegerType');

/**
 * @type StaRHsStatus
 */

var StaRHsStatus = exports.StaRHsStatus = function StaRHsStatus(cycleShared, cycleReceived, cycleLeft, totalShared, totalReceived) {
  _classCallCheck(this, StaRHsStatus);

  ZeroOrPositiveIntegerType(cycleShared);
  ZeroOrPositiveIntegerType(cycleReceived);
  ZeroOrPositiveIntegerType(cycleLeft);
  ZeroOrPositiveIntegerType(totalShared);
  ZeroOrPositiveIntegerType(totalReceived);
  this.cycleShared = cycleShared;
  this.cycleReceived = cycleReceived;
  this.cycleLeft = cycleLeft;
  this.totalShared = totalShared;
  this.totalReceived = totalReceived;
  this.$context = StaRHsStatusContext;
};

var StaRHsStatusContext = exports.StaRHsStatusContext = 'https://github.com/ResourcefulHumans/staRHs-models#StaRHsStatus';
var StaRHsStatusType = exports.StaRHsStatusType = (0, _tcomb.irreducible)('StaRHsStatusType', function (x) {
  return x instanceof StaRHsStatus;
});